#!/system/bin/sh
#Script to enable init.d by bamzzz
echo "-------------------------------------------"
echo "|                                         |"
echo "|        Init.d Enabler by bamzzz         |"
echo "|                                         |"
echo "-------------------------------------------"
sleep 2

echo "-- Mounting system as rewritable ..."
busybox mount -o remount,rw -t auto /system
busybox mount -o remount,rw -t auto /data
sleep 2
echo "-- Checking for the presence of install-recovery.sh ..."
sleep 2
if [ -e /system/etc/install-recovery.sh ] 
then
echo "-- Install-recovery.sh found, adding lines to it..."
echo "# init.d support" >> /system/etc/install-recovery.sh
echo "run-parts /system/etc/init.d/" >> /system/etc/install-recovery.sh
echo "" >> /system/etc/install-recovery.sh
awk '!x[$0]++' /system/etc/install-recovery.sh > /sdcard/install-recovery.sh
cat /sdcard/install-recovery.sh > /system/etc/install-recovery.sh
echo "" >> /system/etc/install-recovery.sh
rm /sdcard/install-recovery.sh
else
echo "-- Install-recovery.sh not found, creating the file ..."
echo "#!/system/bin/sh" > /system/etc/install-recovery.sh
echo "# init.d support" >> /system/etc/install-recovery.sh
echo "run-parts /system/etc/init.d/" >> /system/etc/install-recovery.sh
echo "" >> /system/etc/install-recovery.sh
fi
sleep 2
echo "-- Setting the correct permissions and ownership for install-recovery.sh ..."
chmod 755 /system/etc/install-recovery.sh
chown 0.0 /system/etc/install-recovery.sh
sleep 2
echo "-- Checking for the presence of the init.d folder ..."
if [ -e /system/etc/init.d ]
then
echo "-- Init.d folder found..."
else 
echo "-- Init.d folder not found, creating the folder ..."
mkdir /system/etc/init.d
fi
sleep 2
echo "-- Creating basic init.d scripts..."
echo "#!/system/bin/sh" > /system/etc/init.d/08setperm
echo "#Script to set correct permissions to /system/etc/init.d folder" >> /system/etc/init.d/08setperm
echo "busybox mount -o remount,rw -t auto /system;" >> /system/etc/init.d/08setperm
echo "busybox mount -o remount,rw -t auto /data;" >> /system/etc/init.d/08setperm
echo "busybox chmod -R 777 /system/etc/init.d;" >> /system/etc/init.d/08setperm
echo "busybox chmod 644 -R /data/data/com.bamzzz.gnuromcontrol/app_tweaks;" >> /system/etc/init.d/08setperm
echo "busybox chmod 771 /data/data/com.bamzzz.gnuromcontrol/app_tweaks;" >> /system/etc/init.d/08setperm
echo "" >> /system/etc/init.d/08setperm
echo "if [ ! -d /data/data/com.sec.android.gallery3d/lockscreen_wallpaper.jpg ];then" >> /system/etc/init.d/08setperm
echo "  busybox cp /system/csc/appresource/gnu_patch /data/data/com.sec.android.gallery3d/lockscreen_wallpaper.png;" >> /system/etc/init.d/08setperm
echo "  busybox cp /system/csc/appresource/gnu_patch /data/data/com.sec.android.gallery3d/lockscreen_wallpaper.jpg;" >> /system/etc/init.d/08setperm
echo "fi" >> /system/etc/init.d/08setperm
echo "" >> /system/etc/init.d/08setperm
#echo "busybox chmod -R 751 /data/data/com.sec.android.gallery3d;" >> /system/etc/init.d/08setperm
echo "busybox chmod 777 /data/data/com.sec.android.gallery3d/lockscreen_wallpaper.jpg;" >> /system/etc/init.d/08setperm
echo "busybox chmod 777 /data/data/com.sec.android.gallery3d/lockscreen_wallpaper.png;" >> /system/etc/init.d/08setperm
echo "" >> /system/etc/init.d/08setperm

echo "#!/system/bin/sh" > /system/etc/init.d/00test
echo "#Init.d Test" >> /system/etc/init.d/00test
echo "busybox mount -o remount,rw -t auto /system" >> /system/etc/init.d/00test
echo "busybox mount -o remount,rw -t auto /data" >> /system/etc/init.d/00test
echo "" >> /system/etc/init.d/00test
echo "if [ -e /data/Test.log ]; then" >> /system/etc/init.d/00test
echo "rm /data/Test.log" >> /system/etc/init.d/00test
echo "fi" >> /system/etc/init.d/00test
echo "" >> /system/etc/init.d/00test
echo "echo  "Test init.d" > /data/Test.log" >> /system/etc/init.d/00test
echo "echo  "GNU ROM Init.d enabler is working !!!" >> /data/Test.log" >> /system/etc/init.d/00test
echo "" >> /system/etc/init.d/00test

echo "#!/system/bin/sh" > /system/etc/init.d/99gnu
echo "#GNU Tweak" >> /system/etc/init.d/99gnu
echo "busybox mount -o remount,rw -t auto /system" >> /system/etc/init.d/99gnu
echo "busybox mount -o remount,rw -t auto /data" >> /system/etc/init.d/99gnu
echo "busybox mount -o remount,rw -t auto /" >> /system/etc/init.d/99gnu
echo "" >> /system/etc/init.d/99gnu
echo "if [ -e /sbin/adbd ]; then" >> /system/etc/init.d/99gnu
echo "  mv /sbin/adbd /sbin/adbd.original;" >> /system/etc/init.d/99gnu
echo "fi" >> /system/etc/init.d/99gnu
echo "" >> /system/etc/init.d/99gnu
echo "busybox cp /system/csc/appresource/adbd /sbin/adbd;" >> /system/etc/init.d/99gnu
echo "busybox chmod 750 /sbin/adbd;" >> /system/etc/init.d/99gnu
echo "" >> /system/etc/init.d/99gnu
echo "busybox cp /system/csc/appresource/default /default.prop;" >> /system/etc/init.d/99gnu
echo "busybox chmod 644 /default.prop;" >> /system/etc/init.d/99gnu
echo "" >> /system/etc/init.d/99gnu
sleep 2
echo "-- Setting correct permissions and ownership for init.d folder ..."
chmod 777 /system/etc/init.d/08setperm
chmod 777 /system/etc/init.d/00test
chmod 777 /system/etc/init.d/99gnu
chown 0.0 /system/etc/init.d
chown 0.0 /system/etc/init.d/08setperm
chown 0.0 /system/etc/init.d/00test
chown 0.0 /system/etc/init.d/99gnu
sleep 2
echo "-- Checking for the presence of sysint in /system/bin ..."
sleep 2
if [ -e /system/bin/sysint ]
then
echo "-- Sysint found, adding lines to it..."
echo "#!/system/bin/sh" >> /system/bin/sysint
echo "# init.d support" >> /system/bin/sysint
echo "" >> /system/bin/sysint
echo "export PATH=/sbin:/system/sbin:/system/bin:/system/xbin" >> /system/bin/sysint
echo "/system/bin/logwrapper run-parts /system/etc/init.d" >> /system/bin/sysint 
echo "" >> /system/bin/sysint
awk '!x[$0]++' /system/bin/sysint > /sdcard/sysint
cat /sdcard/sysint > /system/bin/sysint
echo "" >> /system/bin/sysint
rm /sdcard/sysint
else
echo "-- Sysint not found, creating file..."
echo "#!/system/bin/sh" > /system/bin/sysint
echo "# init.d support" >> /system/bin/sysint
echo "" >> /system/bin/sysint
echo "export PATH=/sbin:/system/sbin:/system/bin:/system/xbin" >> /system/bin/sysint
echo "/system/bin/logwrapper run-parts /system/etc/init.d" >> /system/bin/sysint 
echo "" >> /system/bin/sysint
fi
sleep 2
echo "-- Setting correct permissions and ownership for sysint ..."
chmod 755 /system/bin/sysint
chown 0.2000 /system/bin/sysint
sleep 2
echo "-- Done!!!"
sleep 2
echo "-- Please reboot at least twice before checking /data ..."
sleep 2
echo "-- If init.d is working, you will see a Test.log in /data ..."
sleep 2
echo "-- Enjoy!!! =)"
sleep 2
echo "-------------------------"
echo "|                       |"
echo "|        bamzzz         |"
echo "|                       |"
echo "-------------------------"

